Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/ArtificialAntExpressionGrammar.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/ArtificialAntExpressionGrammar.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/ArtificialAntExpressionGrammar.cs	(revision 5686)
@@ -28,5 +28,5 @@
 namespace HeuristicLab.Problems.ArtificialAnt {
   [StorableClass]
-  public class ArtificialAntExpressionGrammar : DefaultSymbolicExpressionGrammar {
+  public class ArtificialAntExpressionGrammar : SymbolicExpressionGrammar {
 
     public ArtificialAntExpressionGrammar()
@@ -53,26 +53,19 @@
 
       allSymbols.ForEach(s => AddSymbol(s));
-      SetMinSubtreeCount(ifFoodAhead, 2);
-      SetMaxSubtreeCount(ifFoodAhead, 2);
-      SetMinSubtreeCount(prog2, 2);
-      SetMaxSubtreeCount(prog2, 2);
-      SetMinSubtreeCount(prog3, 3);
-      SetMaxSubtreeCount(prog3, 3);
-      SetMinSubtreeCount(move, 0);
-      SetMaxSubtreeCount(move, 0);
-      SetMinSubtreeCount(left, 0);
-      SetMaxSubtreeCount(left, 0);
-      SetMinSubtreeCount(right, 0);
-      SetMaxSubtreeCount(right, 0);
+      SetSubtreeCount(ifFoodAhead, 2, 3);
+      SetSubtreeCount(prog2, 2, 2);
+      SetSubtreeCount(prog3, 3, 3);
+      SetSubtreeCount(move, 0, 0);
+      SetSubtreeCount(left, 0, 0);
+      SetSubtreeCount(right, 0, 0);
 
       // each symbols is allowed as child of the start symbol
-      allSymbols.ForEach(s => SetAllowedChild(StartSymbol, s, 0));
+      allSymbols.ForEach(s => AddAllowedChildSymbol(StartSymbol, s));
+      allSymbols.ForEach(s => AddAllowedChildSymbol(DefunSymbol, s));
 
       // each symbol is allowed as child of all other symbols (except for terminals that have MaxSubtreeCount == 0
-      foreach (var parent in allSymbols) {
-        for (int argIndex = 0; argIndex < GetMaxSubtreeCount(parent); argIndex++) {
-          foreach (var child in allSymbols) {
-            SetAllowedChild(parent, child, argIndex);
-          }
+      foreach (var parent in nonTerminalSymbols) {
+        foreach (var child in allSymbols) {
+          AddAllowedChildSymbol(parent, child);
         }
       }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/ArtificialAntProblem.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/ArtificialAntProblem.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.ArtificialAnt/3.4/ArtificialAntProblem.cs	(revision 5686)
@@ -101,6 +101,6 @@
       get { return EvaluatorParameter; }
     }
-    public IValueParameter<ISymbolicExpressionTreeGrammar> ArtificialAntExpressionGrammarParameter {
-      get { return (IValueParameter<ISymbolicExpressionTreeGrammar>)Parameters["ArtificialAntExpressionGrammar"]; }
+    public IValueParameter<ISymbolicExpressionGrammar> ArtificialAntExpressionGrammarParameter {
+      get { return (IValueParameter<ISymbolicExpressionGrammar>)Parameters["ArtificialAntExpressionGrammar"]; }
     }
     public IValueParameter<IntValue> MaxExpressionLengthParameter {
@@ -173,6 +173,6 @@
       get { return EvaluatorParameter.Value; }
     }
-    public GlobalSymbolicExpressionGrammar ArtificialAntExpressionGrammar {
-      get { return (GlobalSymbolicExpressionGrammar)ArtificialAntExpressionGrammarParameter.Value; }
+    public ArtificialAntExpressionGrammar ArtificialAntExpressionGrammar {
+      get { return (ArtificialAntExpressionGrammar)ArtificialAntExpressionGrammarParameter.Value; }
     }
     public DoubleValue BestKnownQuality {
@@ -211,5 +211,4 @@
       Evaluator evaluator = new Evaluator();
       BoolMatrix world = new BoolMatrix(santaFeAntTrail);
-      ISymbolicExpressionTreeGrammar grammar = new GlobalSymbolicExpressionGrammar(new ArtificialAntExpressionGrammar());
       Parameters.Add(new ValueParameter<BoolValue>("Maximization", "Set to true as the Artificial Ant Problem is a maximization problem.", new BoolValue(true)));
       Parameters.Add(new ValueParameter<ISymbolicExpressionTreeCreator>("SolutionCreator", "The operator which should be used to create new artificial ant solutions.", creator));
@@ -220,5 +219,5 @@
       Parameters.Add(new ValueParameter<IntValue>("MaxFunctionDefinitions", "Maximal number of automatically defined functions in the expression to control the artificial ant.", new IntValue(3)));
       Parameters.Add(new ValueParameter<IntValue>("MaxFunctionArguments", "Maximal number of arguments of automatically defined functions in the expression to control the artificial ant.", new IntValue(3)));
-      Parameters.Add(new ValueParameter<ISymbolicExpressionTreeGrammar>("ArtificialAntExpressionGrammar", "The grammar that should be used for artificial ant expressions.", grammar));
+      Parameters.Add(new ValueParameter<ISymbolicExpressionGrammar>("ArtificialAntExpressionGrammar", "The grammar that should be used for artificial ant expressions.", new ArtificialAntExpressionGrammar()));
       Parameters.Add(new ValueParameter<BoolMatrix>("World", "The world for the artificial ant with scattered food items.", world));
       Parameters.Add(new ValueParameter<IntValue>("MaxTimeSteps", "The number of time steps the artificial ant has available to collect all food items.", new IntValue(600)));
@@ -294,10 +293,10 @@
 
     private void MaxFunctionDefinitionsParameter_ValueChanged(object sender, EventArgs e) {
-      ArtificialAntExpressionGrammar.MaxFunctionDefinitions = MaxFunctionDefinitions.Value;
+      ArtificialAntExpressionGrammar.MaximumFunctionDefinitions = MaxFunctionDefinitions.Value;
       ParameterizeOperators();
       ParameterizeAnalyzers();
     }
     private void MaxFunctionArgumentsParameter_ValueChanged(object sender, EventArgs e) {
-      ArtificialAntExpressionGrammar.MaxFunctionArguments = MaxFunctionArguments.Value;
+      ArtificialAntExpressionGrammar.MaximumFunctionArguments = MaxFunctionArguments.Value;
       ParameterizeOperators();
       ParameterizeAnalyzers();
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/ArithmeticExpressionGrammar.cs	(revision 5686)
@@ -29,5 +29,5 @@
   [StorableClass]
   [Item("ArithmeticExpressionGrammar", "Represents a grammar for functional expressions using only arithmetic operations.")]
-  public class ArithmeticExpressionGrammar : DefaultSymbolicExpressionGrammar, ISymbolicDataAnalysisGrammar {
+  public class ArithmeticExpressionGrammar : SymbolicExpressionGrammar, ISymbolicDataAnalysisGrammar {
 
     [StorableConstructor]
@@ -59,23 +59,18 @@
 
       foreach (var funSymb in functionSymbols) {
-        SetMinSubtreeCount(funSymb, 1);
-        SetMaxSubtreeCount(funSymb, 3);
+        SetSubtreeCount(funSymb, 1, 3);
       }
-      SetMinSubtreeCount(constant, 0);
-      SetMaxSubtreeCount(constant, 0);
-      SetMinSubtreeCount(variableSymbol, 0);
-      SetMaxSubtreeCount(variableSymbol, 0);
+      SetSubtreeCount(constant, 0, 0);
+      SetSubtreeCount(variableSymbol, 0, 0);
 
       // allow each symbol as child of the start symbol
       foreach (var symb in allSymbols) {
-        SetAllowedChild(StartSymbol, symb, 0);
+        AddAllowedChildSymbol(StartSymbol, symb);
       }
 
       // allow each symbol as child of every other symbol (except for terminals that have maxSubtreeCount == 0)
-      foreach (var parent in allSymbols) {
-        for (int i = 0; i < GetMaxSubtreeCount(parent); i++)
-          foreach (var child in allSymbols) {
-            SetAllowedChild(parent, child, i);
-          }
+      foreach (var parent in functionSymbols) {
+        foreach (var child in allSymbols)
+          AddAllowedChildSymbol(parent, child);
       }
     }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/FullFunctionalExpressionGrammar.cs	(revision 5686)
@@ -21,4 +21,5 @@
 
 using System.Collections.Generic;
+using System.Linq;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,5 +30,5 @@
   [StorableClass]
   [Item("FullFunctionalExpressionGrammar", "Represents a grammar for functional expressions using all available functions.")]
-  public class FullFunctionalExpressionGrammar : DefaultSymbolicExpressionGrammar, ISymbolicDataAnalysisGrammar {
+  public class FullFunctionalExpressionGrammar : SymbolicExpressionGrammar, ISymbolicDataAnalysisGrammar {
     [StorableConstructor]
     protected FullFunctionalExpressionGrammar(bool deserializing) : base(deserializing) { }
@@ -92,36 +93,28 @@
 
       foreach (var funSymb in functionSymbols) {
-        SetMinSubtreeCount(funSymb, 1);
-        SetMaxSubtreeCount(funSymb, 3);
+        SetSubtreeCount(funSymb, 1, 3);
       }
       foreach (var funSymb in unaryFunctionSymbols) {
-        SetMinSubtreeCount(funSymb, 1);
-        SetMaxSubtreeCount(funSymb, 1);
+        SetSubtreeCount(funSymb, 1, 1);
       }
       foreach (var funSymb in binaryFunctionSymbols) {
-        SetMinSubtreeCount(funSymb, 2);
-        SetMaxSubtreeCount(funSymb, 2);
+        SetSubtreeCount(funSymb, 2, 2);
+      }
+      foreach (var terminalSymbol in terminalSymbols) {
+        SetSubtreeCount(terminalSymbol, 0, 0);
       }
 
-      foreach (var terminalSymbol in terminalSymbols) {
-        SetMinSubtreeCount(terminalSymbol, 0);
-        SetMaxSubtreeCount(terminalSymbol, 0);
-      }
-
-      SetMinSubtreeCount(@if, 3);
-      SetMaxSubtreeCount(@if, 3);
+      SetSubtreeCount(@if, 3, 3);
 
 
       // allow each symbol as child of the start symbol
       foreach (var symb in allSymbols) {
-        SetAllowedChild(StartSymbol, symb, 0);
+        AddAllowedChildSymbol(StartSymbol, symb);
       }
 
       // allow each symbol as child of every other symbol (except for terminals that have maxSubtreeCount == 0)
-      foreach (var parent in allSymbols) {
-        for (int i = 0; i < GetMaxSubtreeCount(parent); i++)
-          foreach (var child in allSymbols) {
-            SetAllowedChild(parent, child, i);
-          }
+      foreach (var parent in allSymbols.Except(terminalSymbols)) {
+        foreach (var child in allSymbols)
+          AddAllowedChildSymbol(parent, child);
       }
     }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Grammars/TypeCoherentExpressionGrammar.cs	(revision 5686)
@@ -29,5 +29,5 @@
   [StorableClass]
   [Item("TypeCoherentExpressionGrammar", "Represents a grammar for functional expressions in which special syntactic constraints are enforced so that boolean and real-valued expressions are not mixed.")]
-  public class TypeCoherentExpressionGrammar : DefaultSymbolicExpressionGrammar, ISymbolicDataAnalysisGrammar {
+  public class TypeCoherentExpressionGrammar : SymbolicExpressionGrammar, ISymbolicDataAnalysisGrammar {
 
     [StorableConstructor]
@@ -123,29 +123,25 @@
 
       foreach (var unaryFun in unaryFunctionSymbols.Concat(unaryBooleanFunctionSymbols)) {
-        SetMinSubtreeCount(unaryFun, 1);
-        SetMaxSubtreeCount(unaryFun, 1);
+        SetSubtreeCount(unaryFun, 1, 1);
       }
       foreach (var binaryFun in binaryFunctionSymbols.Concat(binaryBooleanFunctionSymbols).Concat(relationalFunctionSymbols)) {
-        SetMinSubtreeCount(binaryFun, 2);
-        SetMaxSubtreeCount(binaryFun, 2);
+        SetSubtreeCount(binaryFun, 2, 2);
       }
 
       foreach (var terminalSymbol in terminalSymbols) {
-        SetMinSubtreeCount(terminalSymbol, 0);
-        SetMaxSubtreeCount(terminalSymbol, 0);
+        SetSubtreeCount(terminalSymbol, 0, 0);
       }
 
-      SetMinSubtreeCount(@if, 3);
-      SetMaxSubtreeCount(@if, 3);
+      SetSubtreeCount(@if, 3, 3);
 
 
       // allow only real-valued expressions as child of the start symbol
       foreach (var symb in realValuedSymbols) {
-        SetAllowedChild(StartSymbol, symb, 0);
+        AddAllowedChildSymbol(StartSymbol, symb);
       }
 
       foreach (var symb in unaryFunctionSymbols) {
         foreach (var childSymb in realValuedSymbols) {
-          SetAllowedChild(symb, childSymb, 0);
+          AddAllowedChildSymbol(symb, childSymb);
         }
       }
@@ -153,32 +149,29 @@
       foreach (var symb in binaryFunctionSymbols) {
         foreach (var childSymb in realValuedSymbols) {
-          SetAllowedChild(symb, childSymb, 0);
-          SetAllowedChild(symb, childSymb, 1);
+          AddAllowedChildSymbol(symb, childSymb);
         }
       }
 
       foreach (var childSymb in booleanSymbols) {
-        SetAllowedChild(@if, childSymb, 0);
+        AddAllowedChildSymbol(@if, childSymb, 0);
       }
       foreach (var childSymb in realValuedSymbols) {
-        SetAllowedChild(@if, childSymb, 1);
-        SetAllowedChild(@if, childSymb, 2);
+        AddAllowedChildSymbol(@if, childSymb, 1);
+        AddAllowedChildSymbol(@if, childSymb, 2);
       }
 
       foreach (var symb in relationalFunctionSymbols) {
         foreach (var childSymb in realValuedSymbols) {
-          SetAllowedChild(symb, childSymb, 0);
-          SetAllowedChild(symb, childSymb, 1);
+          AddAllowedChildSymbol(symb, childSymb);
         }
       }
       foreach (var symb in binaryBooleanFunctionSymbols) {
         foreach (var childSymb in booleanSymbols) {
-          SetAllowedChild(symb, childSymb, 0);
-          SetAllowedChild(symb, childSymb, 1);
+          AddAllowedChildSymbol(symb, childSymb);
         }
       }
       foreach (var symb in unaryBooleanFunctionSymbols) {
         foreach (var childSymb in booleanSymbols) {
-          SetAllowedChild(symb, childSymb, 0);
+          AddAllowedChildSymbol(symb, childSymb);
         }
       }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interfaces/ISymbolicDataAnalysisGrammar.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interfaces/ISymbolicDataAnalysisGrammar.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interfaces/ISymbolicDataAnalysisGrammar.cs	(revision 5686)
@@ -23,5 +23,5 @@
 
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
-  public interface ISymbolicDataAnalysisGrammar : ISymbolicExpressionTreeGrammar {
+  public interface ISymbolicDataAnalysisGrammar : ISymbolicExpressionGrammar {
   }
 }
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/SymbolicDataAnalysisExpressionTreeInterpreterTest.cs	(revision 5686)
@@ -25,5 +25,4 @@
 using System.Linq;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.DataAnalysis.Symbolic;
 using HeuristicLab.Random;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
@@ -59,9 +58,9 @@
       var twister = new MersenneTwister(31415);
       var dataset = Util.CreateRandomDataset(twister, Rows, Columns);
-      var grammar = new GlobalSymbolicExpressionGrammar(new FullFunctionalExpressionGrammar());
-      grammar.MaxFunctionArguments = 0;
-      grammar.MaxFunctionDefinitions = 0;
-      grammar.MinFunctionArguments = 0;
-      grammar.MinFunctionDefinitions = 0;
+      var grammar = new FullFunctionalExpressionGrammar();
+      grammar.MaximumFunctionArguments = 0;
+      grammar.MaximumFunctionDefinitions = 0;
+      grammar.MinimumFunctionArguments = 0;
+      grammar.MinimumFunctionDefinitions = 0;
       var randomTrees = Util.CreateRandomTrees(twister, dataset, grammar, N, 1, 100, 0, 0);
       double[] estimation = new double[Rows];
@@ -78,9 +77,9 @@
       var twister = new MersenneTwister(31415);
       var dataset = Util.CreateRandomDataset(twister, Rows, Columns);
-      var grammar = new GlobalSymbolicExpressionGrammar(new ArithmeticExpressionGrammar());
-      grammar.MaxFunctionArguments = 0;
-      grammar.MaxFunctionDefinitions = 0;
-      grammar.MinFunctionArguments = 0;
-      grammar.MinFunctionDefinitions = 0;
+      var grammar = new ArithmeticExpressionGrammar();
+      grammar.MaximumFunctionArguments = 0;
+      grammar.MaximumFunctionDefinitions = 0;
+      grammar.MinimumFunctionArguments = 0;
+      grammar.MinimumFunctionDefinitions = 0;
       var randomTrees = Util.CreateRandomTrees(twister, dataset, grammar, N, 1, 100, 0, 0);
       double[] estimation = new double[Rows];
Index: branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/Util.cs
===================================================================
--- branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/Util.cs	(revision 5685)
+++ branches/DataAnalysis Refactoring/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Tests/Util.cs	(revision 5686)
@@ -45,9 +45,9 @@
 
 
-    public static ISymbolicExpressionTree[] CreateRandomTrees(MersenneTwister twister, Dataset dataset, ISymbolicExpressionTreeGrammar grammar, int popSize) {
+    public static ISymbolicExpressionTree[] CreateRandomTrees(MersenneTwister twister, Dataset dataset, ISymbolicExpressionGrammar grammar, int popSize) {
       return CreateRandomTrees(twister, dataset, grammar, popSize, 1, 200, 3, 3);
     }
 
-    public static ISymbolicExpressionTree[] CreateRandomTrees(MersenneTwister twister, Dataset dataset, ISymbolicExpressionTreeGrammar grammar,
+    public static ISymbolicExpressionTree[] CreateRandomTrees(MersenneTwister twister, Dataset dataset, ISymbolicExpressionGrammar grammar,
       int popSize, int minSize, int maxSize,
       int maxFunctionDefinitions, int maxFunctionArguments) {
@@ -57,5 +57,5 @@
       ISymbolicExpressionTree[] randomTrees = new ISymbolicExpressionTree[popSize];
       for (int i = 0; i < randomTrees.Length; i++) {
-        randomTrees[i] = ProbabilisticTreeCreator.Create(twister, grammar, maxSize, 10, maxFunctionDefinitions, maxFunctionArguments);
+        randomTrees[i] = ProbabilisticTreeCreator.Create(twister, grammar, maxSize, 10);
       }
       return randomTrees;
